eps=1e-2;
$fn=120;
railing = 10; // diameter of beams at the top
split=0;

module tower()
{
  union()
  {
    translate([-300,-300,0])
    cube([600,600,1850]);
    
    for (a=[0,180,270])
    {
      rotate([0,0,a+45])
      {
        translate([0,-260,0])
        rotate([90,0,0])
        linear_extrude(height=200)
        {
          polygon( 
            points=[[0,0],[50,0],[50,800],[0,900],[-50,800],[-50,0],[0,0]]
          );
        }
        translate([0,-310,0])
        rotate([90,0,0])
        linear_extrude(height=200)
        {
          polygon( 
            points=[[0,0],[50,0],[50,400],[0,500],[-50,400],[-50,0],[0,0]]
          );
        }
      }
    }

    
    translate([0,0,1850])
    cylinder(r=500/2,h=3000-1850);
    translate([0,0,3000-20])
    cylinder(r=500/2+40,h=20);
    translate([0,0,3000-20-20])
    cylinder(r=500/2+30,h=20);
    
    translate([0,0,3000-20-20-20])
    for (a=[0:8:359])
    {
      rotate([0,0,a])
      translate([0,-500/2-20,0])
      {
        translate([-10,0,0])
        cube([20,30,20]);  
        translate([0,+20,-30])
        scale([1,2,1])
        cylinder(r2=10,r1=3,h=30);
        
      }
    }
    
    for (a=[0:45:359])
    {
      rotate([0,0,a+360/16])
      {
        translate([130,0,3000])
        cylinder(r=railing/2,h=400);
        rotate([0,0,45/2])
        translate([-50,-120,3000])
        cube([100,railing,100]);
        rotate([0,0,45/2])
        translate([-50,-120,3300])
        cube([100,10,100]);
      
        translate([130,0,3410])
        rotate([0,-30,0])
        cylinder(r=railing/2,h=265);
      }
    }
    
    translate([0,0,3640])
    sphere(r=railing);
    
    rotate([0,0,360/16])
    {
      translate([0,0,3400])
      cylinder(r1=135,r2=145,h=10,$fn=8);
      translate([0,0,3410])
      cylinder(r1=145,r2=0,h=100,$fn=8);
    }
    
    translate([0,0,3000])
    difference()
    {
      union()
      {
        cylinder(r=500/2+20, h=120);
        translate([0,0,110])
        cylinder(r=500/2+35, h=10);
        translate([0,0,100])
        cylinder(r=500/2+32, h=10);
      }
      cylinder(r=500/2+20-20, h=150);
    }
    
    for (b=[0,90,180,270])
    {
      for (a=[90/5:90/5:89])
      {
        rotate([0,0,a+b])
        translate([0,260,3000])
        difference()
        {
          translate([-25,0,0])
          cube([50,20,120]);
          union()
          {
            translate([-30/2,1,0])
            cube([30,20,80]);
            translate([0,1,80])
            rotate([-90,0,0])
            cylinder(r=30/2,h=20);
          }
        }
      }
    }
        
    for (a=[0,90,180,270])
    {
      rotate([0,0,a])
      {
        translate([0,260,2700])
        sphere(r=10);

        translate([0,260,2700])
        cylinder(r=10,h=250);

        translate([0,265,2900])
        cylinder(r1=0,r2=35,h=50,$fn=4);

        translate([0,265,2950])
        cylinder(r=35,h=250,$fn=4);

        translate([0,265,3200])
        cylinder(r1=35,r2=0,h=80,$fn=4);
      }
      
      rotate([0,0,a])
      {
        translate([75,-300,1850])
        rotate([0,-90,0])
        linear_extrude(height=150)
        {
          polygon( 
            points=[[0,0],[650,0],[700,70],[0,70],[0,0]]
          );
        }
        
        translate([80+75+30,-300,1850])
        rotate([0,-90,0])
        linear_extrude(height=80)
        {
          polygon( 
            points=[[0,0],[450,0],[480,40],[0,40],[0,0]]
          );
        }
        translate([+80-75-30-80,-300,1850])
        rotate([0,-90,0])
        linear_extrude(height=80)
        {
          polygon( 
            points=[[0,0],[450,0],[480,40],[0,40],[0,0]]
          );
        }
        
        translate([-300,-300,1850])
        cube([80,80,200]);
        
        translate([-300,-300,1850+200])
        intersection()
        {
          translate([80,80,0])
          rotate([0,0,45])
          cylinder(r1=1.4*80,r2=0,h=30,$fn=4);
          
          cube([80,80,100]);
        }
      }
    }
    
  }
}

module window_cutout(width=85, height=140+85/2, frame=10, rows=3, cols=2)
{
  difference()
  {
    translate([0,-50,0])
    union()
    {
      translate([0,0,height-width/2])
      rotate([-90,0,0])
      cylinder(r=width/2,h=250);
      translate([-width/2,0,0])
      cube([width,250,height-width/2]);
    }
    
    union()
    {
      translate([-(width+2*eps)/2,10,-eps])
      difference()
      {
        cube([width+2*eps,10,height+2*eps]);
        
        union()
        {
          translate([width/2,-eps,height-width/2])
          rotate([-90,0,0])
          intersection()
          {
            cylinder(r=width/2-frame,h=20);
            translate([-width/2,-width,-eps])
            cube([width,width,20+2*eps]);
          }
          translate([frame,-eps,frame])
          cube([width-2*frame,20,height-width/2-frame]);
        }
      }
      
      for (c=[1:cols-1])
      {
        translate([c*width/cols-width/2-frame/2,10,0])
        cube([frame,10,height-width/2]);
      }
      
      if (rows > 0)
      {
        for (r=[1:rows-1])
        {
          translate([-width/2,10,r*(height-width/2)/rows-frame/2])
          cube([width,10,frame]);
        }

        translate([-width/2,10,(height-width/2)-frame/2])
        cube([width,10,frame]);
      }
    }
  }
}

module t2()
{
  difference()
  {
    tower();
    
    union()
    {
      for (a=[0,90,180,270])
      {
        for (h=[1270,1620])
        {
          rotate([0,0,a])
          translate([0,-300+19,h])
          window_cutout();
        }
        
        rotate([0,0,a])
        translate([0,-290,460])
        window_cutout(height=300,rows=4);
        
      }

      for (a=[0,270])
      {
        for (h=[930])
        {
          rotate([0,0,a])
          translate([0,-300+19,h])
          window_cutout();
        }
        
        rotate([0,0,a])
        translate([0,-290,460])
        window_cutout(height=300,rows=4);
        
      }
      
      for (b=[0,90,180,270])
      {
        for (a=[35,55])
        {
            rotate([0,0,a+b])
            translate([0,-245,2600])
            window_cutout(cols=2,rows=4,width=50);
        }
        
        rotate([0,0,b+45])
        translate([0,-245,2300])
        window_cutout(cols=2,rows=4,width=50);

        rotate([0,0,b])
        translate([0,-300,1980])
        window_cutout(cols=2,rows=3,width=70);

        rotate([0,0,b])
        translate([-60,-300-eps,1850])
        cube([120,10,80]);

      }
      
    translate([0,-460,0])
    window_cutout(width=160,height=240,cols=1,rows=0);
      
      translate([0,0,-eps])
      cylinder(r=110,h=3200);
      for (a=[0,90,180,270])
      {
        rotate([0,0,a])
        {
          translate([-65-150,300-10,850])
          cube([150,100,950]);
          translate([-70,300-20,850])
          cube([140,100,950]);
          translate([65,300-10,850])
          cube([150,100,950]);
          
          translate([-70-70,300-10,1800])
          rotate([-90,0,0])
          scale([1,.5,1])
          cylinder(r=150/2,h=100);
          translate([0,300-20,1800])
          rotate([-90,0,0])
          scale([1,.5,1])
          cylinder(r=140/2,h=100);
          translate([+70+70,300-10,1800])
          rotate([-90,0,0])
          scale([1,.5,1])
          cylinder(r=150/2,h=100);
        }
      }
      
      for(a=[0,90,180,270])
      {
        for (pos=[[-260,1600],[260,1600],[-145,1850],[145,1850]])
        {
          rotate([0,0,a])
          translate([pos[0],-300-eps,pos[1]])
          {
            translate([-20,0,0])
            cube([40,10,350]);
            translate([0,0,350])
            scale([1,1,3])
            rotate([-90,0,0])
            cylinder(r=20,h=10);
          }
        }
        
        rotate([0,0,a])
        translate([0,-300-eps,2200])
        {
          translate([-50,0,0])
          cube([100,10,180]);
          translate([0,0,180])
          scale([1,1,2])
          rotate([-90,0,0])
          cylinder(r=50,h=10);
        }
      }
    }
  }
}


module full_tower()
{
  t2();

  translate([-300-160,300+200,0])
  difference()
  {
    union()
    {
      rotate([0,0,360/16])
      cylinder(r=180*1.307,h=800,$fn=8);
  
      difference()
      {
        translate([0,0,750])
        rotate([0,0,360/16])
        cylinder(r=180*1.307+10,h=50+180,$fn=8);
        
        union()
        {
          translate([0,0,750])
          for (a=[0:45:359])
          {
            rotate([0,0,a])
            for (x=[15,45,75,-15,-45,-75])
            {
              translate([x,0,0])
              scale([1,1,2])
              rotate([90,0,0])
              cylinder(r=15,h=250);
            }
          }
        }
      }
    }
  
    union()
    {
      rotate([0,0,-45])
      translate([0,250,150])
      window_cutout(width=100,height=240,cols=1,rows=0);
      
      translate([0,0,800])
      rotate([0,0,360/16])
      cylinder(r=180*1.307-20,h=182,$fn=8);
      
      for (a=[0:45:359])
      {
        rotate([0,0,a])
        {
          translate([-40,150,820])
          cube([80,100,200]);
          translate([-60,150,900])
          cube([120,100,200]);
        }
      }
      
      for (a=[0:360/8:369])
      {
        rotate([0,0,a])
        translate([0,-215,500])
        window_cutout(width=60,height=150,cols=1,rows=0);
        
        translate([0,0,-eps])
        cylinder(r=130,h=700);
      }
    }
  }
  
  translate([0,300,0])
  difference()
  {
    union()
    {
      cube([300,300,750]);
      
      translate([0,0,750])
      linear_extrude(height=50,scale=0)
      {
        square([300,300]);
      }
    }
    
    union()
    {
      translate([150,340,500])
      window_cutout(width=80,height=180,cols=1,rows=0);
  
      translate([150,340,150])
      window_cutout(width=160,height=240,cols=1,rows=0);
    }
  }
  
  translate([-300,300,0])
  difference()
  {
    union()
    {
      cube([300,300,1080]);
      
      translate([30,30+300-60,1080])
      union()
      {
        translate([-30,-30,0])
        cube([60,60,150]);
        translate([0,0,150])
        linear_extrude(height=30,scale=0)
        {
          translate([-30,-30])
          square([60,60]);
        }
      }
    
      translate([150,150,1080])
      union()
      {
        linear_extrude(height=300,scale=0)
        {
          translate([-140,-140])
          square([280,280]);
        }
        linear_extrude(height=200,scale=0)
        {
          translate([-160,-160])
          square([320,320]);
        }
      }
      
      translate([150,150,1080-50])
      difference()
      {
        union()
        {
          translate([-160,-160,25])
          cube([320,320,25]);
          
          linear_extrude(height=25,scale=320/300)
          {
            translate([-150,-150])
            square([300,300]);
          }
        }
        union()
        {
          for (a=[0,90])
          {
            rotate([0,0,a])
            for (x=[-100,0,100])
            {
              translate([x,0,0])
              scale([1,1,.7])
              rotate([90,0,0])
              cylinder(r=50,h=400,center=true);
            }
          }
        }
      }
    }
    
    union()
    {
      translate([40,40,-eps])
      cube([300-2*40,300-2*40,750]);
      
      translate([150,300-30,500])
      window_cutout(width=80,height=140,cols=1,rows=0);
      
      translate([150,300+40,860])
      window_cutout(width=80,height=180,cols=1,rows=0);
  
      translate([300+40,150,860])
      rotate([0,0,-90])
      window_cutout(width=80,height=180,cols=1,rows=0);
  
      translate([-(+40),150,860])
      rotate([0,0,90])
      window_cutout(width=80,height=180,cols=1,rows=0);
  
    }
  }
}

if (split==0)
{
  full_tower();
}
if (split==1)
{
  difference()
  {
    full_tower();
    
    union()
    {
      translate([-650/2,-650/2,1820])
      cube([650,650,2000]);
    }
  }
}
if (split==2)
{
  translate([0,0,-1820])
  intersection()
  {
    full_tower();
    
    union()
    {
      translate([-650/2,-650/2,1820])
      cube([650,650,2000]);

    }
  }

}